package net.wanji.web.task;

import lombok.extern.slf4j.Slf4j;
import net.wanji.feign.service.UtcFeignClients;
import net.wanji.web.entity.TDeviceStatusInfo;
import net.wanji.web.mapper.TDeviceStatusMapper;
import net.wanji.web.util.HttpRestUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import java.util.Objects;

/**
 * @author duanruiming
 * @date 2023/01/03 10:43
 */
@Component
@Slf4j
public class SignalStatusTask {

    @Autowired
    private HttpRestUtil httpRestUtil;

    @Value("${utcServiceUrl}")
    private String utcServiceUrl;
    @Value("${syncDeviceSatusUrn}")
    private String syncDeviceSatusUrl;

    @Autowired
    private UtcFeignClients utcFeignClients;

    @Autowired
    private TDeviceStatusMapper tDeviceStatusMapper;

    @Scheduled(fixedRate = 5 * 60 * 1000)
    public void syncSignalStatus() {
        net.wanji.feign.entity.JsonViewObject jsonViewObject1 = utcFeignClients.runningStatusAlarm();
        System.out.println(jsonViewObject1);
//        try {
//            // 远程通过UTC服务获取信号机状态
//            JsonViewObject jsonViewObject = httpRestUtil.doPost(utcServiceUrl.concat(syncDeviceSatusUrl), null, "", JsonViewObject.class);
//            if (Objects.isNull(jsonViewObject) || jsonViewObject.getCode() != 200) {
//                log.error("定时任务同步信号机设备状态远程utcService调用异常，url:".concat(utcServiceUrl.concat("/signalStatus/runningStatusAlarm")));
//                return;
//            }
//            List<Map<String, Object>> content = (List<Map<String, Object>>) jsonViewObject.getContent();
//            Map<String, Object> result = content.get(0);
//            String signalId = (String) result.get("signalId");
//            Integer currentSignalStatus = result.get("status") == null ? 0 : (Integer) result.get("status");
//            Integer currentFaultType = result.get("faultType") == null ? 0 : (Integer) result.get("faultType");
//
//            // 当前服务数据库状态
//            LambdaQueryWrapper<TDeviceStatusInfo> lambdaQueryWrapper = new LambdaQueryWrapper<>();
//            if (StringUtils.isNotEmpty(signalId)) {
//                lambdaQueryWrapper.eq(TDeviceStatusInfo::getCode, signalId);
//                TDeviceStatusInfo tDeviceStatusInfo = tDeviceStatusMapper.selectOne(lambdaQueryWrapper);
//                if (isExucuteUpdate(currentSignalStatus, currentFaultType, tDeviceStatusInfo)) {
//                    tDeviceStatusInfo.setStatus(currentSignalStatus);
//                    tDeviceStatusInfo.setFaultType(currentFaultType);
//                    tDeviceStatusMapper.updateById(tDeviceStatusInfo);
//                }
//            }
//        } catch (Exception e) {
//            log.error("定时任务同步信号机设备状态远程utcService调用异常", e);
//        }
    }

    private static boolean isExucuteUpdate(Integer currentSignalStatus, Integer currentFaultType, TDeviceStatusInfo tDeviceStatusInfo) {
        return Objects.nonNull(tDeviceStatusInfo) && (currentSignalStatus != tDeviceStatusInfo.getStatus() || currentFaultType != tDeviceStatusInfo.getFaultType());
    }
}
